#include "AutomatonTest.h"

#include <iostream>

void AutomatonTest::setUp(){
    
}

void AutomatonTest::tearDown(){
   /* delete automaton1d;
    delete automaton2d;
    delete automaton3d;
*/
	}

void AutomatonTest::testConstructor1d(){
  /*  ///----------------------------------all the elements of a 1D automaton---------------
    dimSizes1D[0] = x;
    int kk = 0;
    for(int i = 0; i < x; ++i){
        kk = kk + 1;
        grid1d[i] = kk;
    }
    for(int i = 0; i < x; ++i){
        grid1d2[i] = grid1d[i];
    }
    ///----------------------------------end all the elements of a 1D automaton---------------
    //first create all the structure of the net and test is properties
    automaton1d = new Automaton<int>(&grid1d[0], dimSizes1D, dimencions1D); 
   // automaton1d->iterateOverTheSatesArray();
*/
}//----------------------------------end testConstructor1d() ------------

void AutomatonTest::testConstructor2d(){
  /*  ///----------------------------------all the elements of a 2D automaton---------------
    dimSizes2D[0] = x;
    dimSizes2D[1] = y;
    int kk = 0;
    for(int i = 0; i < x; ++i)
    for(int j = 0; j < y; ++j){
        kk = kk + 1;
        grid2d[i][j] = kk;
    }
    for(int i = 0; i < x; ++i)
    for(int j = 0; j < y; ++j){
        grid2d2[i][j] = grid2d[i][j];
    }
    ///----------------------------------end all the elements of a 2D automaton---------------
    
    automaton2d = new Automaton<int>(&grid2d[0][0], dimSizes2D, dimencions2D);    
   // automaton2d->iterateOverTheSatesArray();
*/
}//-----------------------------------end testConstructor2d() -----------

void AutomatonTest::testConstructor3d(){
  /*  ///----------------------------------all the elements of a 3D automaton---------------
    dimSizes3D[0] = x;
    dimSizes3D[1] = y;
    dimSizes3D[2] = z;
    int kk = 0;
    for(int i = 0; i < x; ++i)
    for(int j = 0; j < y; ++j)
    for(int k = 0; k < z; ++k){
        kk = kk + 1;
        grid3d[i][j][k] = kk;
    }
    for(int i = 0; i < x; ++i)
    for(int j = 0; j < y; ++j)
    for(int k = 0; k < z; ++k){
        grid3d2[i][j][k] = grid3d[i][j][k];
    }
    ///----------------------------------end all the elements of a 3D automaton---------------
    automaton3d = new Automaton<int>(&grid3d[0][0][0], dimSizes3D, dimencions3D);    
    //automaton3d->iterateOverTheSatesArray();
*/
}//-----------------------------------end testConstructor3d()------------
//test void Automaton<T>::getNodePointer() method	
void AutomatonTest::testGetNodePointerMethod(){

	//---------------1D case-----------------------
	//first initialize all the variables
    
	//the dimencions's sizeses vector
	dimSizes1D[0] = x;
  
	//the t states matrix
    int kk = 0;
	for(int i = 0; i < x; ++i){
        kk = kk + 1;
        grid1d[i] = kk;
    }
	//and de t+1 state matrix
	for(int i = 0; i < x; ++i){
        grid1d2[i] = grid1d[i];
    }
    //then create the automaton
    automaton1d = new Automaton<int>(&grid1d[0], dimSizes1D, dimencions1D);    
	
	//test the method for all the elements in the states
	//matrix
	//the copyDimSizes[] array is the position vector to test
	//and the copyPointerToNodes pointer is the moved pointer
	//we have to test that the pointer is really pointing
	//to the desaired direction (specify by copyDimSizes[] array)
	
	
	//for all the element in the states matrix
	for(int i = 0; i < automaton1d->dimSizes[0];++i){

		//set te position vector to test
		automaton1d->copyDimSizes[0] = i;
		//move the vector copyPointerToNodes to the specific
		//direction
		automaton1d->getNodePointer();
		//test if the pointer is rigth
		CPPUNIT_ASSERT_EQUAL(grid1d[i],*(automaton1d->copyPointerToNodes));
	}
	//---------------END 1D case-----------------------

	//---------------2D case-----------------------
	//first initialize all the variables
    
	//the dimencions's sizeses vector
	dimSizes2D[0] = x;
    dimSizes2D[1] = y;
	
	//the t states matrix
    kk = 0;
    for(int i = 0; i < x; ++i)
    for(int j = 0; j < y; ++j){
        kk = kk + 1;
        grid2d[i][j] = kk;
    }
	//and de t+1 state matrix
    for(int i = 0; i < x; ++i)
    for(int j = 0; j < y; ++j){
        grid2d2[i][j] = grid2d[i][j];
    }
    //then create the automaton
    automaton2d = new Automaton<int>(&grid2d[0][0], dimSizes2D, dimencions2D);    
	
	//test the method for all the elements in the states
	//matrix
	//the copyDimSizes[] array is the position vector to test
	//and the copyPointerToNodes pointer is the moved pointer
	//we have to test that the pointer is really pointing
	//to the desaired direction (specify by copyDimSizes[] array)
	
	
	//for all the element in the states matrix
	for(int i = 0; i < automaton2d->dimSizes[0];++i)
	for(int j = 0; j < automaton2d->dimSizes[0];++j){

		//set te position vector to test
		automaton2d->copyDimSizes[0] = i;
		automaton2d->copyDimSizes[1] = j;
		//move the vector copyPointerToNodes to the specific
		//direction
		automaton2d->getNodePointer();
		//test if the pointer is rigth
		CPPUNIT_ASSERT_EQUAL(grid2d[i][j],*(automaton2d->copyPointerToNodes));
	}
	//---------------END 2D case-----------------------
	
	//---------------3D case-----------------------
	//first initialize all the variables
    
	//the dimencions's sizeses vector
	dimSizes3D[0] = x;
    dimSizes3D[1] = y;
    dimSizes3D[2] = z;
	
	//the t states matrix
    kk = 0;
    for(int i = 0; i < x; ++i)
    for(int j = 0; j < y; ++j)
    for(int k = 0; k < z; ++k){
        kk = kk + 1;
        grid3d[i][j][k] = kk;
    }
	//and de t+1 state matrix
    for(int i = 0; i < x; ++i)
    for(int j = 0; j < y; ++j)
    for(int k = 0; k < z; ++k){
        grid3d2[i][j][k] = grid3d[i][j][k];
    }
    //then create the automaton
    automaton3d = new Automaton<int>(&grid3d[0][0][0], dimSizes3D, dimencions3D);    
	
	//test the method for all the elements in the states
	//matrix
	//the copyDimSizes[] array is the position vector to test
	//and the copyPointerToNodes pointer is the moved pointer
	//we have to test that the pointer is really pointing
	//to the desaired direction (specify by copyDimSizes[] array)
	
	
	//for all the element in the states matrix
	for(int i = 0; i < automaton3d->dimSizes[0];++i)
	for(int j = 0; j < automaton3d->dimSizes[0];++j)
	for(int k = 0; k < automaton3d->dimSizes[0];++k){

		//set te position vector to test
		automaton3d->copyDimSizes[0] = i;
		automaton3d->copyDimSizes[1] = j;
		automaton3d->copyDimSizes[2] = k;
		//move the vector copyPointerToNodes to the specific
		//direction
		automaton3d->getNodePointer();
		//test if the pointer is rigth
		CPPUNIT_ASSERT_EQUAL(grid3d[i][j][k],*(automaton3d->copyPointerToNodes));
	}
	//---------------END 3D case-----------------------
	
}

//test void Automaton<T>::getNodePointer(vector<int> position) method
void AutomatonTest::testGetNodePointerMethod2(){
	//test void Automaton<T>::getNodePointer(vector<int> position) method
	
	//---------------1D case-----------------------
	//first initialize all the variables
    
	//the position vector
	vector<int> position1d;

	//the dimencions's sizeses vector
	dimSizes1D[0] = x;
  
	//the t states matrix
    int kk = 0;
	for(int i = 0; i < x; ++i){
        kk = kk + 1;
        grid1d[i] = kk;
    }
	//and de t+1 state matrix
	for(int i = 0; i < x; ++i){
        grid1d2[i] = grid1d[i];
    }
    //then create the automaton
    automaton1d = new Automaton<int>(&grid1d[0], dimSizes1D, dimencions1D);    
	
	//test the method for all the elements in the states
	//matrix
	//the copyDimSizes[] array is the position vector to test
	//and the copyPointerToNodes pointer is the moved pointer
	//we have to test that the pointer is really pointing
	//to the desaired direction (specify by copyDimSizes[] array)
	
	
	//for all the element in the states matrix
	for(int i = 0; i < automaton1d->dimSizes[0];++i){

		//set te position vector to test
		position1d.clear();
		position1d.push_back(i);
		position1d.reserve(1);

		//move the vector copyPointerToNodes to the specific
		//direction
		automaton1d->getNodePointer(position1d);
		//test if the pointer is rigth
		
		CPPUNIT_ASSERT_EQUAL(grid1d[i],*(automaton1d->copyPointerToNodes));
	}
	//---------------END 1D case-----------------------

	//---------------2D case-----------------------
	//first initialize all the variables
    
	//the position vector
	vector<int> position2d;

	//the dimencions's sizeses vector
	dimSizes2D[0] = x;
    dimSizes2D[1] = y;
	
	//the t states matrix
    kk = 0;
    for(int i = 0; i < x; ++i)
    for(int j = 0; j < y; ++j){
        kk = kk + 1;
        grid2d[i][j] = kk;
    }
	//and de t+1 state matrix
    for(int i = 0; i < x; ++i)
    for(int j = 0; j < y; ++j){
        grid2d2[i][j] = grid2d[i][j];
    }
    //then create the automaton
    automaton2d = new Automaton<int>(&grid2d[0][0], dimSizes2D, dimencions2D);    
	
	//test the method for all the elements in the states
	//matrix
	//the copyDimSizes[] array is the position vector to test
	//and the copyPointerToNodes pointer is the moved pointer
	//we have to test that the pointer is really pointing
	//to the desaired direction (specify by copyDimSizes[] array)
	
	
	//for all the element in the states matrix
	for(int i = 0; i < automaton2d->dimSizes[0];++i)
	for(int j = 0; j < automaton2d->dimSizes[0];++j){

		position2d.clear();
		//set te position vector to test
		position2d.push_back(i);
		position2d.push_back(j);
		
		position2d.reserve(2);
		
		//move the vector copyPointerToNodes to the specific
		//direction
		automaton2d->getNodePointer(position2d);
		//test if the pointer is rigth
		CPPUNIT_ASSERT_EQUAL(grid2d[i][j],*(automaton2d->copyPointerToNodes));
	}
	//---------------END 2D case-----------------------
	
	//---------------3D case-----------------------
	//first initialize all the variables
    

	//the position vector
	vector<int> position3d;

	//the dimencions's sizeses vector
	dimSizes3D[0] = x;
    dimSizes3D[1] = y;
    dimSizes3D[2] = z;
	
	//the t states matrix
    kk = 0;
    for(int i = 0; i < x; ++i)
    for(int j = 0; j < y; ++j)
    for(int k = 0; k < z; ++k){
        kk = kk + 1;
        grid3d[i][j][k] = kk;
    }
	//and de t+1 state matrix
    for(int i = 0; i < x; ++i)
    for(int j = 0; j < y; ++j)
    for(int k = 0; k < z; ++k){
        grid3d2[i][j][k] = grid3d[i][j][k];
    }
    //then create the automaton
    automaton3d = new Automaton<int>(&grid3d[0][0][0], dimSizes3D, dimencions3D);    
	
	//test the method for all the elements in the states
	//matrix
	//the copyDimSizes[] array is the position vector to test
	//and the copyPointerToNodes pointer is the moved pointer
	//we have to test that the pointer is really pointing
	//to the desaired direction (specify by copyDimSizes[] array)
	
	
	//for all the element in the states matrix
	for(int i = 0; i < automaton3d->dimSizes[0];++i)
	for(int j = 0; j < automaton3d->dimSizes[0];++j)
	for(int k = 0; k < automaton3d->dimSizes[0];++k){

		position3d.clear();
		//set te position vector to test
		position3d.push_back(i);
		position3d.push_back(j);
		position3d.push_back(k);
		
		position3d.reserve(3);

		//move the vector copyPointerToNodes to the specific
		//direction
		automaton3d->getNodePointer(position3d);
		//test if the pointer is rigth
		CPPUNIT_ASSERT_EQUAL(grid3d[i][j][k],*(automaton3d->copyPointerToNodes));
	}
	//---------------END 3D case-----------------------
	
}
//test void Automaton<T>::getNodePointer(int position[]) method	
void AutomatonTest::testGetNodePointerMethod3(){
	//test void Automaton<T>::getNodePointer(int position[]) method
	//---------------1D case-----------------------
	//first initialize all the variables
    
	//the dimencions's sizeses vector
	dimSizes1D[0] = x;
  
	//the t states matrix
    int kk = 0;
	for(int i = 0; i < x; ++i){
        kk = kk + 1;
        grid1d[i] = kk;
    }
	//and de t+1 state matrix
	for(int i = 0; i < x; ++i){
        grid1d2[i] = grid1d[i];
    }
    //then create the automaton
    automaton1d = new Automaton<int>(&grid1d[0], dimSizes1D, dimencions1D);    
	
	//test the method for all the elements in the states
	//matrix
	//the copyDimSizes[] array is the position vector to test
	//and the copyPointerToNodes pointer is the moved pointer
	//we have to test that the pointer is really pointing
	//to the desaired direction (specify by copyDimSizes[] array)
	
	
	//for all the element in the states matrix
	for(int i = 0; i < automaton1d->dimSizes[0];++i){

		//set te position vector to test
		automaton1d->copyDimSizes[0] = i;
		//move the vector copyPointerToNodes to the specific
		//direction
		automaton1d->getNodePointer(automaton1d->copyDimSizes);
		//test if the pointer is rigth
		CPPUNIT_ASSERT_EQUAL(grid1d[i],*(automaton1d->copyPointerToNodes));
	}
	//---------------END 1D case-----------------------

	//---------------2D case-----------------------
	//first initialize all the variables
    
	//the dimencions's sizeses vector
	dimSizes2D[0] = x;
    dimSizes2D[1] = y;
	
	//the t states matrix
    kk = 0;
    for(int i = 0; i < x; ++i)
    for(int j = 0; j < y; ++j){
        kk = kk + 1;
        grid2d[i][j] = kk;
    }
	//and de t+1 state matrix
    for(int i = 0; i < x; ++i)
    for(int j = 0; j < y; ++j){
        grid2d2[i][j] = grid2d[i][j];
    }
    //then create the automaton
    automaton2d = new Automaton<int>(&grid2d[0][0], dimSizes2D, dimencions2D);    
	
	//test the method for all the elements in the states
	//matrix
	//the copyDimSizes[] array is the position vector to test
	//and the copyPointerToNodes pointer is the moved pointer
	//we have to test that the pointer is really pointing
	//to the desaired direction (specify by copyDimSizes[] array)
	
	
	//for all the element in the states matrix
	for(int i = 0; i < automaton2d->dimSizes[0];++i)
	for(int j = 0; j < automaton2d->dimSizes[0];++j){

		//set te position vector to test
		automaton2d->copyDimSizes[0] = i;
		automaton2d->copyDimSizes[1] = j;
		//move the vector copyPointerToNodes to the specific
		//direction
		automaton2d->getNodePointer(automaton2d->copyDimSizes);
		//test if the pointer is rigth
		CPPUNIT_ASSERT_EQUAL(grid2d[i][j],*(automaton2d->copyPointerToNodes));
	}
	//---------------END 2D case-----------------------
	
	//---------------3D case-----------------------
	//first initialize all the variables
    
	//the dimencions's sizeses vector
	dimSizes3D[0] = x;
    dimSizes3D[1] = y;
    dimSizes3D[2] = z;
	
	//the t states matrix
    kk = 0;
    for(int i = 0; i < x; ++i)
    for(int j = 0; j < y; ++j)
    for(int k = 0; k < z; ++k){
        kk = kk + 1;
        grid3d[i][j][k] = kk;
    }
	//and de t+1 state matrix
    for(int i = 0; i < x; ++i)
    for(int j = 0; j < y; ++j)
    for(int k = 0; k < z; ++k){
        grid3d2[i][j][k] = grid3d[i][j][k];
    }
    //then create the automaton
    automaton3d = new Automaton<int>(&grid3d[0][0][0], dimSizes3D, dimencions3D);    
	
	//test the method for all the elements in the states
	//matrix
	//the copyDimSizes[] array is the position vector to test
	//and the copyPointerToNodes pointer is the moved pointer
	//we have to test that the pointer is really pointing
	//to the desaired direction (specify by copyDimSizes[] array)
	
	
	//for all the element in the states matrix
	for(int i = 0; i < automaton3d->dimSizes[0];++i)
	for(int j = 0; j < automaton3d->dimSizes[0];++j)
	for(int k = 0; k < automaton3d->dimSizes[0];++k){

		//set te position vector to test
		automaton3d->copyDimSizes[0] = i;
		automaton3d->copyDimSizes[1] = j;
		automaton3d->copyDimSizes[2] = k;
		//move the vector copyPointerToNodes to the specific
		//direction
		automaton3d->getNodePointer(automaton3d->copyDimSizes);
		//test if the pointer is rigth
		CPPUNIT_ASSERT_EQUAL(grid3d[i][j][k],*(automaton3d->copyPointerToNodes));
	}
	//---------------END 3D case-----------------------
	
}

//test iterateOverTheSatesArray(int index) method
void AutomatonTest::testIterateOverTheSatesArray(){	
	//---------------1D case-----------------------
	//first initialize all the variables
    
	//the dimencions's sizeses vector
	dimSizes1D[0] = x;
  
	//the t states matrix
    int kk = 0;
	for(int i = 0; i < x; ++i){
        kk = kk + 1;
        grid1d[i] = kk;
    }
	//and de t+1 state matrix
	for(int i = 0; i < x; ++i){
        grid1d2[i] = grid1d[i];
    }
    //then create the automaton
    automaton1d = new Automaton<int>(&grid1d[0], dimSizes1D, dimencions1D);    
	
	//create the graph 
	automaton1d->iterateOverTheSatesArray();
	
	//modify all the states matrix with the new onedimensional
	//container, the graph
	for(size_t i = 0; i < automaton1d->graph.size(); ++i){
		*(automaton1d->graph[i].centerCell) = -10;
	}
	//and tests the correctnes of the method 	
	//for all the element in the states matrix
	for(int i = 0; i < automaton1d->dimSizes[0];++i){

	CPPUNIT_ASSERT_EQUAL(-10,*(automaton1d->copyPointerToNodes));
	}
	//---------------END 1D case-----------------------
	
	//---------------2D case-----------------------
	//first initialize all the variables
    
	//the dimencions's sizeses vector
	dimSizes2D[0] = x;
    dimSizes2D[1] = y;
	
	//the t states matrix
    kk = 0;
    for(int i = 0; i < x; ++i)
    for(int j = 0; j < y; ++j){
        kk = kk + 1;
        grid2d[i][j] = kk;
    }
	//and de t+1 state matrix
    for(int i = 0; i < x; ++i)
    for(int j = 0; j < y; ++j){
        grid2d2[i][j] = grid2d[i][j];
    }
    //then create the automaton
    automaton2d = new Automaton<int>(&grid2d[0][0], dimSizes2D, dimencions2D);    
	
	//create the graph 
	automaton2d->iterateOverTheSatesArray();
	
	//modify all the states matrix with the new onedimensional
	//container, the graph
	for(size_t i = 0; i < automaton2d->graph.size(); ++i){
		*(automaton2d->graph[i].centerCell) = -10;
	}
	//and tests the correctnes of the method 	
	//for all the element in the states matrix
	for(int i = 0; i < automaton2d->dimSizes[0];++i)
	for(int j = 0; j < automaton2d->dimSizes[0];++j){

		CPPUNIT_ASSERT_EQUAL(-10,*(automaton2d->copyPointerToNodes));
	}
	//---------------END 2D case-----------------------
	
	//---------------3D case-----------------------
	//first initialize all the variables
    
	//the dimencions's sizes vector
	dimSizes3D[0] = x;
    dimSizes3D[1] = y;
    dimSizes3D[2] = z;
	
	//the t states matrix
    kk = 0;
    for(int i = 0; i < x; ++i)
    for(int j = 0; j < y; ++j)
    for(int k = 0; k < z; ++k){
        kk = kk + 1;
        grid3d[i][j][k] = kk;
    }
	//and de t+1 state matrix
    for(int i = 0; i < x; ++i)
    for(int j = 0; j < y; ++j)
    for(int k = 0; k < z; ++k){
        grid3d2[i][j][k] = grid3d[i][j][k];
    }
    //then create the automaton
    automaton3d = new Automaton<int>(&grid3d[0][0][0], dimSizes3D, dimencions3D);    
	
	//create the graph 
	automaton3d->iterateOverTheSatesArray();
	
	//modify all the states matrix with the new onedimensional
	//container, the graph
	for(size_t i = 0; i < automaton3d->graph.size(); ++i){
		*(automaton3d->graph[i].centerCell) = -10;
	}
	//and tests the correctnes of the method 	
	//for all the element in the states matrix
	for(int i = 0; i < automaton3d->dimSizes[0];++i)
	for(int j = 0; j < automaton3d->dimSizes[0];++j)
	for(int k = 0; k < automaton3d->dimSizes[0];++k){
		CPPUNIT_ASSERT_EQUAL(-10,*(automaton3d->copyPointerToNodes));
	}
	//---------------END 3D case-----------------------
	
}

//test createNode() method
void AutomatonTest::testCreateNode(){}
CppUnit::Test *AutomatonTest::suite() {
  
  // create a test suite
  CppUnit::TestSuite *AutomatonsuiteOfTests = 
	  new CppUnit::TestSuite("AutomatonTest");
  
  // add the tests ---------
  AutomatonsuiteOfTests->addTest
  (new CppUnit::TestCaller<AutomatonTest>
  ("testConstructor1d", &AutomatonTest::testConstructor1d));
  
  AutomatonsuiteOfTests->addTest
  (new CppUnit::TestCaller<AutomatonTest>
  ("testConstructor2d", &AutomatonTest::testConstructor2d));
  
  AutomatonsuiteOfTests->addTest
  (new CppUnit::TestCaller<AutomatonTest>
  ("testConstructor3d", &AutomatonTest::testConstructor3d));
  
  AutomatonsuiteOfTests->addTest
  (new CppUnit::TestCaller<AutomatonTest>
  ("testGetNodePointerMethod", &AutomatonTest::testGetNodePointerMethod));
  
  
  AutomatonsuiteOfTests->addTest
  (new CppUnit::TestCaller<AutomatonTest>
  ("testGetNodePointerMethod2", &AutomatonTest::testGetNodePointerMethod2));
   
  
  AutomatonsuiteOfTests->addTest
  (new CppUnit::TestCaller<AutomatonTest>
  ("testGetNodePointerMethod3", &AutomatonTest::testGetNodePointerMethod3)); 
	
  AutomatonsuiteOfTests->addTest
  (new CppUnit::TestCaller<AutomatonTest>
  ("testIterateOverTheSatesArray", &AutomatonTest::testIterateOverTheSatesArray));

  AutomatonsuiteOfTests->addTest
  (new CppUnit::TestCaller<AutomatonTest>
  ("testCreateNode", &AutomatonTest::testCreateNode));

/*AutomatonsuiteOfTests->addTest
  (new CppUnit::TestCaller<AutomatonTest>
  ("testVertexCreation", &AutomatonTest::testVertexCreation));
  */
  return AutomatonsuiteOfTests;
}//-------*AutomatonTest::suite()-----------
