#include "Map.h"

#include <iostream>

vector <vector<int> > Map::setVertex(const vector<int> position){
    
    vertex.clear();
    neighborhood->calculateNeighborhood(position);
    copyVertex = neighborhood->getNeighborhood();
    //for all neigbors check if they exist in the actual topology
    for(unsigned int i = 0; i < copyVertex.size(); ++i){
        if( !(topology->isOutOfBounds(copyVertex[i])) )
                vertex.push_back( topology->getPos(copyVertex[i]) );    
    }  
     
    return vertex; 

}
