/*TO:do:::::

set vertex saca un vector y esta mal, que saque un bool 
como respuesta si el vecindario existe????
*/

#ifndef Map_h
#define Map_h

#include <vector>
#include <iostream>

#include "Topology.h"
#include "Neighborhood.h"
#include "TowerNeighborhood.h"

using namespace std;

class Map {
    
    //the map have a pointer to a topology object
    Topology *topology;
    
    //and a Neighborhood element to make the soup :-)
    Neighborhood *neighborhood;
    
    //the creation of the vertex of the net is keep in
    //a container
    vector< vector<int> > vertex;
    
    //need a copy vector to calculaions in setVertex method and
    //dont whant to create a new one every time the method is called
    vector< vector<int> > copyVertex;
    
    public:
        
        //constructor
        Map(Topology *top, Neighborhood *hood): topology(top), neighborhood(hood){}
        // The copy-constructor:
        Map(const Map &m): topology(m.topology), neighborhood(m.neighborhood){}   
        
        //-------get set methods------------------------------
        void setTopology(Topology *top){topology = top;} 
        
        void setNeighborhood(Neighborhood *hood){neighborhood = hood;}
        
        vector < vector<int> > getVertex(){return vertex;}       
        vector <vector<int> > setVertex(const vector<int> position);
        /*this is the main method of the class, in this method
        the Topology and Neighborhood objects are mixed
        to creata the vertex of the net, the cellular automata
        net*/
        
        //-------end get set methods--------------------------
        
};
#endif
