#include "Topology.h"

Topology::Topology(int dim, int norm):dimension(dim),dimNormalized(norm){
     //because we know the number of dimension's object's that
     //we are gone to use, reserve the specific space of memory
     dimensions.reserve(dimension);   
    //create and add the dimensions
    for(int i=0; i< dim; ++i){
        if(norm != 0){//if u want to normalize some dim's
                dimensions.push_back(Dimension(100, true));
                //quits from the count the normalized dimension
                norm -= 1;            
        }
        else //if u want's boudary's dimension
                dimensions.push_back(Dimension(100, false));           
    }
}

/*Topology::~Topology(){   
    delete &dimensions;
}*/

int Topology::getDimNormalized(){
    
    //the count of dimensions normalized
    int normDimensions = 0;
    
    //count for all dimensions
    for(int i=0;i<int(dimensions.size());++i){
        if(dimensions[i].getNormalized())
        normDimensions += 1;
    }
    return normDimensions;
}
bool Topology::isOutOfBounds(vector<int> vect){
    
    //check all the coordinates in the vector  
    for(int i=0; i< int(dimensions.size()); ++i){
        //if some coordinate is out of bounds
        if( dimensions[i].isOutOfBounds(vect[i]) ){
               return  true;}                
    }
    return false;//if nothing happens is in bounds
}

vector<int> Topology::getPos(vector<int> vect){
    //transform all the coordinates in the new ones
    //is a must!!! to check if they are out of bounds first!
    //with the isOutOfBound method
    for(int i=0; i < int(vect.size()); ++i){
        vect[i] = dimensions[i].getPos(vect[i]);                
    }
    
    return vect;
}
