#include  "TowerNeighborhood.h"

void TowerNeighborhood
::calculateNeighborhood(const vector<int> position){
    
    //first empty the position vect and the neighborhood vect
    neighbor.clear();
    neighborhood.clear();
    
    // to make the calculations easy start with  a copy of 
    //the position vector, this copy is gone to be modify
    //and push_back in the neighborhood vector, without 
    //modify the given position vector 
    neighbor = position;
    
    //make the calculations for each dimmension fo 
    //the position vector, is size
    for(unsigned int i = 0; i < neighbor.size() ; ++i){
        
        //make a number of neigbor in one direccion
        //this number depends on the size of the class         
        for(int j = 0; j < size; ++j ){
                neighbor[i] = neighbor[i] + 1;   
                neighborhood.push_back(neighbor);
        }//---end for j----------------   
        
        neighbor.clear();
        neighbor = position;
        
        //make a number of neigbor in the other direccion
        //this number depends on the size of the class
        for(int j = 0; j < size; ++j ){
                neighbor[i] = neighbor[i] - 1;   
                neighborhood.push_back(neighbor);
        }//---end for j----------------
         
        neighbor.clear();
        neighbor = position;
    
    }// end i for ----   
    
}//----calculateNeighborhood(const vector<int> &position)----

